<?php
/**
 * Model object generated by: Skipper (http://www.skipper18.com)
 * Do not modify this file manually.
 */

namespace App\AbstractModels;

use Illuminate\Database\Eloquent\Model;

abstract class AbstractInsurance extends Model
{
    /**  
     * Primary key type.
     * 
     * @var string
     */
    protected $keyType = 'bigInteger';
    
    /**  
     * The attributes that should be cast to native types.
     * 
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'created_at' => 'datetime',
        'updated_at' => 'datetime',
        'name' => 'string',
        'acronym' => 'string'
    ];
    
    /**  
     * The guarded property should contain an array of attributes that you do not want to be mass assignable.
     * 
     * @var array
     */
    protected $guarded = [];
    
    public function demands()
    {
        return $this->hasMany('\App\Demand', 'insurance_id', 'id');
    }
    
    public function exams()
    {
        return $this->belongsToMany('\App\Exam', 'exam_price_by_insurance', 'insurance_id', 'exam_id')->withPivot('id', 'price', 'tm', 'gap_tm', 'gap', 'base_price');
    }
    
    public function patients()
    {
        return $this->belongsToMany('\App\Patient', 'insurance_to_patient', 'insurance_id', 'patient_id')->withPivot('insurance_nr', 'expiration_date');
    }
}
